﻿#include <iostream>
#include <vector>
#include "histogram.h"
#include <algorithm>
#include "text.h"
#include "svg.h"
#include <curl/curl.h>

using namespace std;
struct Input {
    vector<double> numbers;
    size_t bin_count{};
    vector<string> colors;
};

Input
input_data(istream& inn, bool promt) {
    if (promt == true) {
        cerr << "Sovet:" << endl;
    }
    size_t number_count;
    cerr << "Enter number_count: ";
    inn >> number_count;
    Input in;
    cerr << "Enter numbers: ";
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        inn >> in.numbers[i];
    }
    cerr << "Enter bin_count: ";
    inn >> in.bin_count;
    in.colors.resize(in.bin_count);
    sort(begin(in.numbers), end(in.numbers));
    in.numbers.erase(unique(begin(in.numbers), end(in.numbers)), end(in.numbers));
    number_count = in.numbers.size();
    cerr << "Enter colors: ";
    for (size_t i = 0; i < in.bin_count; i++) {
        inn >> in.colors[i];
    }
    return in;
}



int main(int argc, char* argv[]) {
    if (argc > 1) {
        cout << argc << "\n";
        for (int i = 0; i < argc; i++) {
            cout << "argv[" << i << "] = " << argv[i] << "\n";
        }
    }
    curl_global_init(CURL_GLOBAL_ALL);
    bool promt = true;
    auto in = input_data(cin, promt);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins, in.colors);
    return 0;
}